%define apache_version 2.2.4

%def_without M24
%def_without M30
%def_without libdb42
%def_without libdb43
%def_without libdb44

%define apache_release_base alt24
%if_with M24
%define apache_release_base alt23.M24.1
%endif
%if_with M30
%define apache_release_base alt23.M30.1
%endif
%define apache_release_libdb %nil
%if_with libdb42
%define apache_release_libdb .libdb4.2
%endif
%if_with libdb43
%define apache_release_libdb .libdb4.3
%endif
%if_with libdb44
%define apache_release_libdb .libdb4.4
%endif
%define apache_release_suff %nil
%define apache_release %apache_release_base%apache_release_suff%apache_release_libdb

%define n_aprver 1.2.8
%define n_apr_release_devel -alt1.1
%define n_aprutil_release_devel -alt1.1
%define n_apr_devel_ver %n_aprver%n_apr_release_devel
%define n_aprutil_devel_ver %n_aprver%n_aprutil_release_devel

%define mmn 20051115
%define n_dbver 4.4
%if_with M30
%define n_dbver 4.3
%endif
%if_with M24
%define n_dbver 4.2
%endif
%if_with libdb42
%define n_dbver 4.2
%endif
%if_with libdb43
%define n_dbver 4.3
%endif
%if_with libdb44
%define n_dbver 4.4
%endif

# do we need to co-exist with apache-ru ?
%def_enable apache_ru_compat
# if we do, what suffix to use ?
%define branch 2
# do we use native apr/apu ?
%def_disable static

# handle initscript style change
%define dist_tag Sisyphus
%if_with M24
%define dist_tag Master
%endif

# name pkg-config pakage
%define n_pkgconfig pkg-config
%if_with M24
%define n_pkgconfig pkgconfig
%endif

%if_enabled apache_ru_compat
%define apache_branch %branch
%else
%define apache_branch %nil
%endif

%define a_name apache%apache_branch
%define a_dname httpd%apache_branch

%define a_bindir %_bindir
%define a_sbindir %_sbindir
%define a_mandir %_mandir
%define a_localstatedir %_var
%define a_logfiledir %_logdir/%a_dname
%define a_includedir %_includedir/%a_name
%define a_runtimedir %_var/run/%a_dname
%define a_proxycachedir %_cachedir/%a_dname
%define a_spooldir %_spooldir/%a_name
%define a_infodir %_infodir
%define a_installbuilddir %a_libdir/build
%define a_apxs %_sbindir/apxs%apache_branch

%define a_libdir %_libdir/%a_name
%define a_libexecdir %a_libdir/modules

%define a_datadir %srv_dir/%a_name
%define a_htdocsdir %a_datadir/html
%define a_cgidir %a_datadir/cgi-bin
%define a_addondocdir %a_datadir/manual-addons
%define a_iconsdir %a_datadir/icons
%define a_manualdir %a_datadir/manual
%define a_errordir %a_datadir/error

%define a_rel_sysconfdir conf
%define a_prefix %_sysconfdir/%a_dname
%define a_exec_prefix %prefix
%define a_sysconfdir %a_prefix/%a_rel_sysconfdir

# Debian`like conf
%define a_mods_available	%a_sysconfdir/mods-available
%define a_mods_enabled		%a_sysconfdir/mods-enabled
%define a_mods_start		%a_sysconfdir/mods-start.d
%define a_ports_available	%a_sysconfdir/ports-available
%define a_ports_enabled		%a_sysconfdir/ports-enabled
%define a_ports_start		%a_sysconfdir/ports-start.d
%define a_sites_available	%a_sysconfdir/sites-available
%define a_sites_enabled		%a_sysconfdir/sites-enabled
%define a_sites_start		%a_sysconfdir/sites-start.d
%define a_extra_available	%a_sysconfdir/extra-available
%define a_extra_enabled		%a_sysconfdir/extra-enabled
%define a_extra_start		%a_sysconfdir/extra-start.d

%define apache_user            %a_name
%define apache_group           %a_name
%define apache_webmaster       webmaster
%define suexec_docroot         /home

%define apache_apr_buildreq "libapr1-devel libaprutil1-devel"
%define apache_apr_config %_bindir/apr-1-config
%define apache_apu_config %_bindir/apu-1-config

# Old macros
%define apache_addonconfdir	%a_sysconfdir/addon.d


Name:    %a_name
Version: %apache_version
Release: %apache_release
License: Apache Software License
Group: System/Servers
Url: http://httpd.apache.org/
Packager: Aleksey Avdeev <solo@altlinux.ru>

Summary: The most widely used Web server on the Internet
Summary(ru_RU.KOI8-R):   - Internet
Summary(uk_UA.KOI8-U): ¦  - Internet

# SVN URL: http://svn.apache.org/repos/asf/httpd/httpd/tags/2.2.4
Source0: httpd-%version.tar

Source10: apache2.favour
Source11: apache2-alt-configs-0.4.tar
Source12: README.ALT.ru_RU.KOI8-R
Source13: apache2-alt-alternatives-0.2.tar

# initscripts for ALM2.2 and friends and current Sisyphus
Source33: httpd2.init.Master
Source35: httpd2.init.Sisyphus

Patch1: apache2-2.2.4-alt-debian.conf-0.10.patch
Patch2: apache2-2.2.4-alt-default_https.conf.in.0.1.patch

Provides: webserver %name = %apache_version-%apache_release

%if_disabled apache_ru_compat
Conflicts: apache-common apache apache-mod_perl
%endif

Obsoletes: %name-init
Requires: %name-mmn = %mmn
Requires: %name-libdb = %n_dbver
Requires: %name-httpd
Requires: vhosts-filesystem

BuildPreReq: libapr1-devel >= %n_apr_devel_ver
BuildPreReq: libaprutil1-devel >= %n_aprutil_devel_ver

# Automatically added by buildreq on Fri Mar 31 2006
BuildRequires: libssl-devel openssl zlib-devel

BuildPreReq: alternatives
BuildPreReq: %n_pkgconfig
BuildPreReq: vhosts-filesystem-devel
%if_enabled static
BuildPreReq: libdb%n_dbver-devel-static
BuildPreReq: libsasl2-devel-static
%endif
BuildPreReq: libdb%n_dbver-devel
BuildPreReq: libgdbm-devel
BuildPreReq: libexpat-devel
BuildPreReq: libpcre-devel
BuildPreReq: openldap libldap-devel
BuildPreReq: libsasl2-devel libsasl2-plugin-gssapi
BuildPreReq: openssl libssl-devel
#following is required by dbmmanage
BuildPreReq: perl-DBM perl-Digest-SHA1 zlib-devel

%description
Apache is a powerful, full-featured, efficient and freely-available
Web server.

This package contains a new (and thus not vary good tested) branch
of Apache web server

%description -l ru_RU.KOI8-R
Apache - , ,  
  -.

          
- Apache.

%package common
Summary: Files common for %name installations
Summary(ru_RU.KOI8-R):     %name
Summary(uk_UA.KOI8-U): ЦΦ   æ %name
Group: System/Servers
Conflicts: %name < 2.2.4-alt17
Requires: libapr1 >= %n_aprver
Requires: libaprutil1 >= %n_aprver
Requires: perl-DBM perl-Digest-SHA1 zlib
Provides: %name-mmn = %mmn
Provides: %name-libdb = %n_dbver

%description common
This package contains files required for both %name package
installations. Install this if you want to install Apache.

%description -l ru_RU.KOI8-R common
    ,   %name.
,    Apache.

%description -l uk_UA.KOI8-U common
  ͦ , ˦ ȦΦ  %name.
צ ,    Apache.

%package httpd-worker
Summary: High speed threaded model for Apache HTTPD 2.1
Summary(ru_RU.KOI8-R):     Apache HTTPD 2.1
Group: System/Servers
PreReq: %name-common
Requires: %name-mmn = %mmn
Requires: %name-libdb = %n_dbver
Provides: %name-httpd = %apache_version-%apache_release

%description httpd-worker
The worker MPM provides a threaded implementation for Apache HTTPD 2.1. It is
considerably faster than the traditional model, and is the recommended MPM.

Worker generally is a good choice for high-traffic servers because it
has a smaller memory footprint than the prefork MPM.

%package httpd-prefork
Summary: Traditional model for Apache HTTPD 2.1
Summary(ru_RU.KOI8-R):    Apache HTTPD 2.1
Group: System/Servers
PreReq: %name-common
Requires: %name-mmn = %mmn
Requires: %name-libdb = %n_dbver
Provides: %name-httpd = %apache_version-%apache_release

%description httpd-prefork
This Multi-Processing Module (MPM) implements a non-threaded,
pre-forking web server that handles requests in a manner similar to
Apache 1.3. It is appropriate for sites that need to avoid threading for
compatibility with non-thread-safe libraries. It is also the best MPM
for isolating each request, so that a problem with a single request will
not affect any other.

It is not as fast, but is considered to be more stable.

%package httpd-event
Summary: Event driven model for Apache HTTPD 2.1
Summary(ru_RU.KOI8-R):    Apache HTTPD 2.1
Group: System/Servers
PreReq: %name-common
Requires: %name-mmn = %mmn
Requires: %name-libdb = %n_dbver
Provides: %name-httpd = %apache_version-%apache_release

%description httpd-event
The event Multi-Processing Module (MPM) is designed to allow more 
requests to be served simultaneously by passing off some processing 
work to supporting threads, freeing up the main threads to work on 
new requests.

This MPM is especially suitable for sites that see extensive KeepAlive traffic

%package devel
Summary: Module development tools for the Apache web server
Summary(ru_RU.KOI8-R):     - Apache
Group: Development/C
Obsoletes: secureweb-devel
PreReq: %name = %apache_version-%apache_release

Obsoletes: %a_name-libapr %a_name-libapr-devel %a_name-libapr-devel %a_name-libaprutil %a_name-libaprutil-devel %a_name-libaprutil-devel
Requires: libapr1-devel >= %n_apr_devel_ver
Requires: libaprutil1-devel >= %n_aprutil_devel_ver

%description devel
The apache-devel package contains the source code for the Apache
Web server you'll need to build Dynamic
Shared Objects (DSOs) for Apache.

If you are installing the Apache Web server and
you want to be able to compile or develop additional modules
for Apache, you'll need to install this package.

%description -l ru_RU.KOI8-R devel
       - Apache,
      (DSO).

   - Apache    
    ,     .

%package manual
Summary: Apache Manual
Summary(ru_RU.KOI8-R):   Apache
Group: Books/Other
Requires: %name >= 2.2.4-alt12
PreReq: %name-common
AutoReq: no

%description manual
This package contains the Apache server documentation in HTML format.

%description -l ru_RU.KOI8-R manual
     - Apache   HTML.

%package mod_ssl
Group: System/Servers
Summary: SSL/TLS module for the Apache HTTP server
Serial: 1
BuildPreReq: libssl-devel
PreReq: openssl
PreReq: %name-common
Requires: %name-mmn = %mmn
Requires: %name-libdb = %n_dbver

%description mod_ssl
The mod_ssl module provides strong cryptography for the Apache Web
server via the Secure Sockets Layer (SSL) and Transport Layer
Security (TLS) protocols.

%package suexec
Summary: Suexec binary for Apache
Summary(ru_RU.KOI8-R):  suexec  Apache
Summary(uk_UA.KOI8-U):  suexec  Apache
Group: System/Servers
PreReq: %name-common
Requires: %name-mmn = %mmn
Requires: %name-libdb = %n_dbver

%description suexec
This package adds suexec to Apache. Suexec provides Apache users the ability
to run CGI and SSI programs under user IDs different from the user ID of the
calling web-server. Normally, when a CGI or SSI program executes, it runs as
the same user who is running the web server.

%description -l ru_RU.KOI8-R suexec
    Apache suexec.     CGI-
 SSI-   ,   UID
-.

%description -l uk_UA.KOI8-U suexec
    Apache suexec.   Ѥ  CGI-
 SSI- Ц Ʀ ,  צҦ צ
UID -.


%add_findprov_lib_path %a_libdir
%define docdir %_docdir/%name-%version

%prep
# We dont need to expand builddir yet

%setup -q -n httpd-%version
%patch1 -p1
%patch2 -p1

# generate ALTLinux Apache layout
echo "
# ALTLinux layout
<Layout ALTLinux>
    prefix:		%a_prefix
    exec_prefix:	%a_exec_prefix
    bindir:		%a_bindir
    sbindir:		%a_sbindir
    libdir:		%a_libdir
    libexecdir:		%a_libexecdir
    mandir:		%a_mandir
    sysconfdir:		%a_sysconfdir
    datadir:		%a_datadir
    iconsdir:		%a_iconsdir
    htdocsdir:		%a_htdocsdir
    manualdir:		%a_manualdir
    cgidir:		%a_cgidir
    includedir:		%a_includedir
    localstatedir:	%a_localstatedir
    runtimedir:		%a_runtimedir
    logfiledir:		%a_logfiledir
    proxycachedir:	%a_proxycachedir
    infodir:		%a_infodir
    installbuilddir:	%a_installbuilddir
    errordir:		%a_errordir
</Layout>
" >> config.layout

# Safety check: prevent build if defined MMN does not equal upstream MMN.
vmmn=`echo MODULE_MAGIC_NUMBER_MAJOR | cpp -include $PWD/include/ap_mmn.h | grep -e '^[0-9]'`
if [ "$vmmn" != "%mmn" ]; then
   : Error: Upstream MMN is now ${vmmn}, packaged MMN is %mmn.
   : Update the mmn macro and rebuild.
   exit 1
fi

%build
function mpmbuild()
{
mpm=$1; shift
mkdir $mpm; pushd $mpm
cat > config.cache <<EOF
ac_cv_func_pthread_mutexattr_setpshared=no
ac_cv_func_sem_open=no
EOF
../configure -C \
	--enable-layout=ALTLinux \
	--with-pcre=%_usr/bin/pcre-config \
	--with-perl=%__perl \
	--with-apr=%apache_apr_config \
	--with-apr-util=%apache_apu_config \
	--enable-suexec --with-suexec \
	--with-suexec-caller=%apache_user \
	--with-suexec-docroot=%suexec_docroot \
	--with-suexec-logfile=%a_logfiledir/suexec.log \
	--with-suexec-bin=%a_sbindir/suexec%apache_branch \
	--with-suexec-uidmin=500 --with-suexec-gidmin=500 \
	--with-suexec-userdir=public_html \
	--enable-so \
	--with-mpm=$mpm \
        --with-devrandom \
        --with-ldap --enable-ldap --enable-auth-ldap --enable-authnz-ldap \
        --enable-cache --enable-disk-cache --enable-mem-cache \
	--enable-ssl --with-ssl \
	--enable-deflate --enable-cgid \
	--enable-proxy --enable-proxy-connect \
	--enable-proxy-http --enable-proxy-ftp \
	--enable-charset_lite=shared \
	$*

%make_build
popd
}

ln -snf %_datadir/apr-1/build/PrintPath build/PrintPath
libtoolize --ltdl
autoheader
autoconf -I %_datadir/apr-1

# Only bother enabling optional modules for main build.
mpmbuild prefork --enable-mods-shared=all --with-program-name=%a_dname

# To prevent most modules being built statically into httpd.worker,
# easiest way seems to be enable them shared.
mpmbuild worker --enable-mods-shared=all  --with-program-name=%a_dname

mpmbuild event --enable-mods-shared=all  --with-program-name=%a_dname

# Verify that the same modules were built into the two httpd binaries
./prefork/%a_dname -l | grep -v prefork > prefork.mods
./worker/%a_dname -l | grep -v worker > worker.mods
./event/%a_dname -l | grep -v event > event.mods
if ( ! diff -u prefork.mods worker.mods ) || ( ! diff -u prefork.mods event.mods ) ; then
  : Different modules built into httpd binaries, will not proceed
  exit 1
fi

%install
# Install README.ALT
install %SOURCE12 ./

# Generate macros for rpm
mkdir -p %buildroot%_sysconfdir/rpm/macros.d

echo "
%%apache_version	%apache_version
%%apache_release	%apache_release

# first we define apache-ru compatible macroses
%%apache_basedir	%a_prefix
%%apache_confdir	%a_sysconfdir
%%apache_addonconfdir	%apache_addonconfdir
%%apache_moduledir	%a_libexecdir
%%apache_logdir	%a_logfiledir
%%apache_addondocdir	%a_addondocdir

%%apache_datadir	%a_datadir
%%apache_htdocsdir	%a_htdocsdir
%%apache_cgibindir	%a_cgidir
%%apache_apxs	%a_apxs

%%apache_user	%apache_user
%%apache_group	%apache_group
%%apache_webmaster	%apache_webmaster
%%suexec_docroot	%suexec_docroot

# This tells apache-based packages what
# APR to require and use
%%apache_apr_buildreq	%apache_apr_buildreq
%%apache_apr_config	%apache_apr_config
%%apache_apu_config	%apache_apu_config

# here goes apache2 specific macroses
# (although not all of them are required
# for building modules)
%%a_rel_sysconfdir	%a_rel_sysconfdir
%%a_name	%a_name
%%a_dname	%a_dname
%%a_prefix	%a_prefix
%%a_exec_prefix	%a_exec_prefix
%%a_bindir	%a_bindir
%%a_sbindir	%a_sbindir
%%a_libdir	%a_libdir
%%a_libexecdir	%a_libexecdir
%%a_mandir	%a_mandir
%%a_sysconfdir	%a_sysconfdir
%%a_datadir	%a_datadir
%%a_iconsdir	%a_iconsdir
%%a_htdocsdir	%a_htdocsdir
%%a_manualdir	%a_manualdir
%%a_addondocdir	%a_addondocdir
%%a_cgidir	%a_cgidir
%%a_includedir	%a_includedir
%%a_localstatedir	%a_localstatedir
%%a_runtimedir 	%a_runtimedir
%%a_logfiledir 	%a_logfiledir
%%a_proxycachedir	%a_proxycachedir
%%a_spooldir	%a_spooldir
%%a_infodir	%a_infodir
%%a_installbuilddir	%a_installbuilddir
%%a_errordir	%a_errordir
%%a_apxs	%a_apxs

# Debian-like conf
%%a_mods_available	%a_mods_available
%%a_mods_enabled	%a_mods_enabled
%%a_mods_start	%a_mods_start
%%a_ports_available	%a_ports_available
%%a_ports_enabled	%a_ports_enabled
%%a_ports_start	%a_ports_start
%%a_sites_available	%a_sites_available
%%a_sites_enabled	%a_sites_enabled
%%a_sites_start	%a_sites_start
%%a_extra_available	%a_extra_available
%%a_extra_enabled	%a_extra_enabled
%%a_extra_start	%a_extra_start
" > %buildroot%_sysconfdir/rpm/macros.d/%name

# Generate sed script for substitute the real paths in configs
sed -ne '/^[[:space:]]*%%[a-zA-Z0-1_]\+[[:space:]]\+[^[:space:]]\+[[:space:]]*$/s/^[[:space:]]*%%\([a-zA-Z0-1_]\+\)[[:space:]]\+\([^[:space:]]\+\)[[:space:]]*$/s|@\1@|\2|g/p' \
	%buildroot%_sysconfdir/rpm/macros.d/%name \
	> SetMacros.sed
echo 's|@name@|%a_dname|g
s|@pidfile@|%a_runtimedir/httpd.pid|g
s|@conffile@|%a_sysconfdir/%a_dname.conf|g
s|@modules@|%a_libexecdir|g
s|@rel_sysconfdir@|%a_rel_sysconfdir|g
s|@vhosts_dir@|%vhosts_dir|g' >> SetMacros.sed

# Classify ab and logresolve as section 1 commands, as they are in /usr/bin
pushd docs/man

mv ab.8 ab%apache_branch.1

%if_enabled apache_ru_compat
MANS="apachectl.8 apxs.8 dbmmanage.1 htdigest.1 htpasswd.1 httpd.8 rotatelogs.8 logresolve.8 suexec.8"
for manpage in $MANS; do
    mv ${manpage} `echo ${manpage}|sed -e "s/\./%apache_branch./"`
done
%endif

mv logresolve%apache_branch.8 logresolve%apache_branch.1
popd

pushd prefork
make DESTDIR=%buildroot install
popd
mv %buildroot%a_sbindir/%a_dname %buildroot%a_sbindir/%a_dname.prefork

# install worker binary
WDIR=worker
install -m 755 $WDIR/%a_dname %buildroot%a_sbindir/%a_dname.worker

# install event binary
WDIR=event
install -m 755 $WDIR/%a_dname %buildroot%a_sbindir/%a_dname.event

#-----------------------------------------------------------------------------------
# Tune up executibles to co-exist with apache-ru
#
pushd %buildroot%a_sbindir
%if_enabled apache_ru_compat
#rename suexec binary to be named that apache is expect it to be
mv suexec suexec%apache_branch
#
# rename tools
# Maybe it's better to push ru-apache-devel before installing devel package
rm envvars-std
for tool in apxs checkgid dbmmanage envvars rotatelogs httxt2dbm; do
    mv ${tool} ${tool}%apache_branch
done
#fix apxs
sed -i -e 's|\(\/envvars\)"|\1%apache_branch"|
s|\(apachectl\)|\1%apache_branch|
' apxs%apache_branch
%endif
# move&rename utilities to /usr/bin
TOOLS="ab htdbm logresolve htpasswd htdigest"
for tool in $TOOLS; do
    mv ${tool} %buildroot%a_bindir/${tool}%apache_branch
done
popd
#
#-----------------------------------------------------------------------------------

pushd %buildroot%a_sysconfdir
tar xvSf %SOURCE11
popd

mkdir -p %buildroot%_altdir
pushd %buildroot%_altdir
tar xvSf %SOURCE13
popd

# mod_ssl bits
for suffix in crl crt csr key prm; do
   mkdir %buildroot%a_sysconfdir/ssl.${suffix}
done

# Makefiles for certificate management
#for ext in crt crl; do
#  install -m 644 ./build/rpm/mod_ssl-Makefile.${ext} \
#	$RPM_BUILD_ROOT%_sysconfdir/httpd/conf/ssl.${ext}/Makefile.${ext}
#done
#ln -s ../../../usr/share/ssl/certs/Makefile $RPM_BUILD_ROOT/etc/httpd/conf

# for holding mod_dav lock database
mkdir -p %buildroot%a_localstatedir/lib/dav

# create a prototype session cache
mkdir -p %buildroot%a_proxycachedir/mod_ssl
touch %buildroot%a_proxycachedir/mod_ssl/scache.{dir,pag,sem}

# create spools
install -d %buildroot%a_spooldir/{,tmp,sessions,uploads}

# Make the MMN accessible to module packages
echo %mmn > %buildroot%a_includedir/.mmn

# symlinks for /etc/httpd2
ln -snf $(relative %buildroot%a_logfiledir %buildroot%a_prefix/logs) %buildroot%a_prefix/logs
ln -snf $(relative %buildroot%a_runtimedir %buildroot%a_prefix/run) %buildroot%a_prefix/run
ln -snf $(relative %buildroot%a_libexecdir %buildroot%a_prefix/modules) %buildroot%a_prefix/modules
ln -snf $(relative %buildroot%a_installbuilddir %buildroot%a_prefix/build) %buildroot%a_prefix/build

# create config dirs for additional modules and Virtual hosts
mkdir %buildroot%apache_addonconfdir

#------------------------------------------------------------------------------------
# tune up configuration files

# Install conf/*-start.d/*.conf
for d in mods ports sites extra; do
	find docs/conf/$d-start.d/ -maxdepth 1 -name '*.conf' -type f -print0 | \
		xargs -r0 install -D -t %buildroot%a_sysconfdir/$d-start.d/
done

pushd %buildroot%a_sysconfdir

find -type f -print0 | \
	xargs -r0 sed -i -e 's/^\([[:space:]]*User\)[[:space:]]\+.*/\1 %apache_user/
s/^\([[:space:]]*Group\)[[:space:]]\+.*/\1 %apache_group/
s/^\([[:space:]]*ServerAdmin\)[[:space:]]\+you/\1 %apache_webmaster/
' httpd*.conf
popd

#------------------------------------------------------------------------------------

#install ALT misc documentation and logos

# Move .../conf/original to %%docdir/original
install -d %buildroot%docdir/
mv %buildroot%a_sysconfdir/original original
touch %buildroot%docdir/original
ln -snf $(relative %buildroot%docdir/original %buildroot%a_sysconfdir/original) %buildroot%a_sysconfdir/original

# docroot
#rm -r %buildroot%a_manualdir/style
##rm %buildroot%a_manualdir/*/*.xml
# Move %%a_manualdir to %%docdir/manual
mv %buildroot%a_manualdir manual
install -d %buildroot%_docdir/%a_name-manual-%apache_version/
touch %buildroot%_docdir/%a_name-manual-%apache_version/manual
ln -snf $(relative %buildroot%_docdir/%a_name-manual-%apache_version/manual %buildroot%a_manualdir) %buildroot%a_manualdir

# install the init script
mkdir -p %buildroot%_initdir
%if "%dist_tag" == "Master"
install -m755 %SOURCE33 \
        %buildroot%_initdir/%a_dname
%else
install -m755 %SOURCE35 \
        %buildroot%_initdir/%a_dname
%endif

# generate sysconfig settings file
mkdir -p %buildroot%_sysconfdir/sysconfig
echo "# Set HTTPD=%a_dname.worker to use a server
# with the thread-based "worker" MPM; BE WARNED that some modules may not
# work correctly with a thread-based MPM; notably PHP will refuse to start.
# Dont't forget to create httpd.worker.conf config file. copying existing
# httpd.conf could be a good starting point.
# (!) Warning: Stop httpd2 service BEFORE changing the following line
#HTTPD=%a_dname.worker
# Or use
#HTTPD=%a_dname.prefork
#
# If you want to force proxied (for example by Apache1) mode, which is
# autodetected by default you could add "-DA1PROXIED"
#OPTIONS="-DA1PROXIED"
" > %buildroot%_sysconfdir/sysconfig/%a_dname


# replace the "official" apachectl by a symlink to the init script
rm -f %buildroot%a_sbindir/apachectl*
ln -s -f $(relative %buildroot%_initdir/%a_dname \
        %buildroot%a_sbindir/apachectl%apache_branch) \
	%buildroot%a_sbindir/apachectl%apache_branch

# Generate logrotate file
mkdir -p %buildroot%_sysconfdir/logrotate.d
echo '%a_logfiledir/*log {
	missingok
	notifempty
	sharedscripts
	create 0644 root %apache_group
	delaycompress
	postrotate
	/sbin/service %a_dname condreload >/dev/null
	endscript
}
'>%buildroot%_sysconfdir/logrotate.d/%a_name

# install addon documentation root
mkdir -p %buildroot%a_addondocdir

###
## Install apachkconfig favour description file
#
mkdir -p %buildroot%apachk_favours_dir
install -m 600 %SOURCE10 %buildroot%apachk_favours_dir/

###
## now remove installed files we ain't gonna use
#
rm -f %buildroot%a_installbuilddir/config.nice \
	%buildroot%a_libexecdir/httpd.exp \
	%buildroot%a_installbuilddir/mkdir.sh \
	%buildroot%a_mandir/man8/apachectl* \
	%buildroot%a_errordir/README

# Substitute the real paths in configs
find %buildroot%_sysconfdir -type f -print0 | \
	xargs -r0 sed -i -f SetMacros.sed

#============ S C R I P T S ==================================================
#
#
%pre
if [ $1 -eq 2 ]; then
	if [ -e %a_sysconfdir/%a_dname.conf ] && \
			! (grep -qs -m1 '^[[:space:]]*[Ii][Nn][Cc][Ll][Uu][Dd][Ee][[:space:]]\+conf/ports-enabled' %a_sysconfdir/%a_dname.conf && \
			grep -qs -m1 '^[[:space:]]*[Ii][Nn][Cc][Ll][Uu][Dd][Ee][[:space:]]\+conf/mods-enabled' %a_sysconfdir/%a_dname.conf && \
			grep -qs -m1 '^[[:space:]]*[Ii][Nn][Cc][Ll][Uu][Dd][Ee][[:space:]]\+conf/sites-enabled' %a_sysconfdir/%a_dname.conf && \
			grep -qs -m1 '^[[:space:]]*[Ii][Nn][Cc][Ll][Uu][Dd][Ee][[:space:]]\+conf/extra-enabled' %a_sysconfdir/%a_dname.conf) ; then
		echo 'Warning: configuration files %a_sysconfdir/%a_dname.conf is old!'
		echo '    Renamed old file %a_sysconfdir/%a_dname.conf'
		echo '    to %a_sysconfdir/%a_dname.conf.rpmsave'
		mv %a_sysconfdir/%a_dname.conf %a_sysconfdir/%a_dname.conf.rpmsave
	fi
	if [ -e %a_sysconfdir/%a_dname.worker.conf ] && \
			[ ! -L %a_sysconfdir/%a_dname.worker.conf ]; then
		echo 'Warning: original configuration files %a_sysconfdir/%a_dname.worker.conf'
		echo '    saved as %a_sysconfdir/%a_dname.worker.conf.rpmold'
		mv %a_sysconfdir/%a_dname.worker.conf %a_sysconfdir/%a_dname.worker.conf.rpmold
	fi
fi
exit 0

%preun
if [ $1 = 0 ]; then
    %preun_service %a_dname
fi
exit 0

%post
if [ ! -e %a_sysconfdir/%a_dname.conf ] && \
		[ -e %a_sysconfdir/%a_dname.conf.rpmnew ]; then
	mv %a_sysconfdir/%a_dname.conf.rpmnew %a_sysconfdir/%a_dname.conf
fi
%_sbindir/a2chkconfig
%post_service %a_dname

%triggerin -- %name-httpd-worker
if [ $1 -eq 2 ] || [ $1 -eq 1 ]; then
	%post_service %a_dname
fi
exit 0

%triggerin -- %name-httpd-prefork
if [ $1 -eq 2 ] || [ $1 -eq 1 ]; then
	%post_service %a_dname
fi
exit 0

%triggerin -- %name-httpd-event
if [ $1 -eq 2 ] || [ $1 -eq 1 ]; then
	%post_service %a_dname
fi
exit 0

%triggerin -- %name-mod_ssl
%_sbindir/a2chkconfig
%post_service %a_dname
exit 0

%triggerin -- %name-suexec
%_sbindir/a2chkconfig
%post_service %a_dname
exit 0

%triggerun -- %name-httpd-worker
if [ $1 -eq 0 ]; then
	%preun_service %a_dname
fi
exit 0

%triggerun -- %name-httpd-prefork
if [ $1 -eq 0 ]; then
	%preun_service %a_dname
fi
exit 0

%triggerun -- %name-httpd-event
if [ $1 -eq 0 ]; then
	%preun_service %a_dname
fi
exit 0

%triggerun -- %name-mod_ssl
%_sbindir/a2chkconfig
%post_service %a_dname
exit 0

%triggerun -- %name-suexec
%_sbindir/a2chkconfig
%post_service %a_dname
exit 0

%triggerpostun -- apache2-manual < 2.2.4-alt12
if [ -e %_docdir/apache2-manual-2.2.4/manual ] && \
		[ -L %_docdir/apache2-manual-2.2.4/manual ]; then
	echo "Delete old symlink %_docdir/apache2-manual-2.2.4/manual"
	rm -f %_docdir/%a_name-%apache_version/manual 2>/dev/null ||:
fi
exit 0

%pre common
# Create user and groups
%_sbindir/groupadd -r -f %apache_group 2>/dev/null ||:
%_sbindir/groupadd -r -f %apache_webmaster 2>/dev/null ||:
%_sbindir/useradd -g %apache_group -c 'Apache2 WWW server' -d %a_datadir -s '/dev/null' \
    -r %apache_user 2>/dev/null ||:
exit 0

%post httpd-worker
%register_alternatives %name-httpd-worker

%triggerpostun httpd-worker -- apache2 < 2.2.4-alt18
%register_alternatives %name-httpd-worker

%postun httpd-worker
%unregister_alternatives %name-httpd-worker

%post httpd-prefork
%register_alternatives %name-httpd-prefork

%triggerpostun httpd-prefork -- apache2 < 2.2.4-alt18
%register_alternatives %name-httpd-prefork

%postun httpd-prefork
%unregister_alternatives %name-httpd-prefork

%post httpd-event
%register_alternatives %name-httpd-event

%triggerpostun httpd-event -- apache2 < 2.2.4-alt18
%register_alternatives %name-httpd-prefork

%postun httpd-event
%unregister_alternatives %name-httpd-event

%pre manual
if [ $1 -eq 2 ] && \
		[ -e %a_manualdir ] && \
		[ ! -L %a_manualdir ] ; then
	echo 'Warning: original %a_manualdir not symlink!'
	echo '    Saved as %a_manualdir.rpmold'
	mv %a_manualdir %a_manualdir.rpmold
fi
exit 0

%post manual
%_sbindir/a2chkconfig
%post_service %a_dname

%postun manual
if [ $1 -eq 0 ] && [ -x %_sbindir/a2chkconfig ] ; then
	%_sbindir/a2chkconfig
	%post_service %a_dname
fi
exit 0

%post mod_ssl
#%_sbindir/ldconfig ### is this needed?
umask 077

if [ ! -f %a_sysconfdir/ssl.key/server.key ] ; then
%_bindir/openssl genrsa -rand /proc/apm:/proc/cpuinfo:/proc/dma:/proc/filesystems:/proc/interrupts:/proc/ioports:/proc/pci:/proc/rtc:/proc/uptime 1024 > %a_sysconfdir/ssl.key/server.key 2> /dev/null
fi

FQDN=`hostname`
if [ "x${FQDN}" = "x" ]; then
   FQDN=localhost.localdomain
fi

if [ ! -f %a_sysconfdir/ssl.crt/server.crt ] ; then
cat << EOF | %_bindir/openssl req -new -key %a_sysconfdir/ssl.key/server.key -x509 -days 365 -out %a_sysconfdir/ssl.crt/server.crt 2>/dev/null
--
SomeState
SomeCity
SomeOrganization
SomeOrganizationalUnit
${FQDN}
root@${FQDN}
EOF
fi

%files common
%attr(2770,root,%apache_group) %dir %a_proxycachedir/
%attr(750,root,%apache_group) %dir %a_spooldir/
%attr(2770,root,%apache_group) %dir %a_spooldir/tmp/
%attr(2770,root,%apache_group) %dir %a_spooldir/sessions/
%attr(2770,root,%apache_group) %dir %a_spooldir/uploads/

%dir %a_prefix/
%a_prefix/logs
%a_prefix/run
%a_prefix/modules

%dir %a_sysconfdir/
%dir %a_extra_available/
%dir %a_extra_enabled/
%dir %a_extra_start/
%dir %a_mods_available/
%dir %a_mods_enabled/
%dir %a_mods_start/
%dir %a_ports_available/
%dir %a_ports_enabled/
%dir %a_ports_start/
%dir %a_sites_available/
%dir %a_sites_enabled/
%dir %a_sites_start/

%dir %a_libdir/
%dir %a_libexecdir/
%attr(0750,root,%apache_group) %dir %a_logfiledir/
%dir %a_runtimedir/

%config(noreplace) %a_sysconfdir/magic
%config(noreplace) %a_sysconfdir/mime.types
%config(noreplace) %a_mods_available/*.load
%config(noreplace) %a_mods_available/*.conf
%exclude %a_mods_available/ssl.load
%exclude %a_mods_available/ssl.conf
%exclude %a_mods_available/suexec.load
%a_sbindir/a2*
%a_mandir/man8/a2*

# everything but mod_ssl.so:
%a_libexecdir/mod_*.so
%exclude %a_libexecdir/mod_ssl.so
%exclude %a_libexecdir/mod_suexec.so

%files httpd-worker
%a_sbindir/%a_dname.worker
%_altdir/%name-httpd-worker

%files httpd-prefork
%a_sbindir/%a_dname.prefork
%_altdir/%name-httpd-prefork

%files httpd-event
%a_sbindir/%a_dname.event
%_altdir/%name-httpd-event

%files
%doc ABOUT_APACHE README CHANGES LICENSE README.ALT*
%doc original

%a_sysconfdir/original

%config(noreplace) %a_sysconfdir/httpd2.conf
%config(noreplace) %a_mods_start/*.conf
%exclude %a_mods_start/*-manual*.conf
%config(noreplace) %a_ports_available/*.conf
%config(noreplace) %a_ports_start/*.conf
%exclude %a_ports_available/https.conf
%config(noreplace) %a_sites_available/*.conf
%config(noreplace) %a_sites_start/*.conf
%exclude %a_sites_available/default_https.conf
%config(noreplace) %a_extra_available/*.conf
%exclude %a_extra_available/httpd-manual*.conf
%config(noreplace) %a_extra_start/*.conf
%exclude %a_extra_start/*-manual*.conf
%dir %apache_addonconfdir/
%config %_initdir/%a_dname
%a_sbindir/apachectl*
%attr(0600,root,root) %config(noreplace) %_sysconfdir/sysconfig/%a_dname

%attr(0644,root,root) %config(noreplace) %_sysconfdir/logrotate.d/%a_name

%apachk_favours_dir/apache2.favour

%a_bindir/ab*
%a_bindir/ht*
%a_bindir/logresolve*
%a_sbindir/rotatelogs*
%a_sbindir/htcacheclean*

%a_sbindir/checkgid*
%a_sbindir/check_forensic*
%a_sbindir/dbmmanage*

%a_sbindir/httxt2dbm*

%dir %a_datadir/
%dir %a_cgidir/
%attr(2775,root,%apache_webmaster) %dir %a_htdocsdir/
%dir %a_iconsdir/
%dir %a_errordir/
%dir %a_errordir/include/
%a_iconsdir/*
%a_htdocsdir/*
%a_cgidir/*

%config(noreplace) %a_errordir/*.var
%config(noreplace) %a_errordir/include/*.html

%attr(0700,%apache_user,%apache_group) %dir %a_localstatedir/lib/dav

%a_mandir/man1/*

%a_mandir/man8/rotatelogs*
%a_mandir/man8/httpd*
%a_mandir/man8/htcacheclean*
%a_mandir/man8/checkgid*
%a_mandir/man8/check_forensic*

%files manual
%doc manual

%a_manualdir
%a_addondocdir
%config(noreplace) %a_mods_start/*-manual*.conf
%config(noreplace) %a_extra_available/httpd-manual*.conf
%config(noreplace) %a_extra_start/*-manual*.conf

%files mod_ssl
%a_libexecdir/mod_ssl.so
%attr(0600,root,root) %config(noreplace) %a_mods_available/ssl.load
%attr(0600,root,root) %config(noreplace) %a_mods_available/ssl.conf
%attr(0600,root,root) %config(noreplace) %a_ports_available/https.conf
%attr(0600,root,root) %config(noreplace) %a_sites_available/default_https.conf
%attr(0700,root,root) %dir %a_sysconfdir/ssl.*
%attr(2770,root,%apache_group) %dir %a_proxycachedir/mod_ssl/
%attr(0600,%apache_user,%apache_group) %ghost %a_proxycachedir/mod_ssl/scache.dir
%attr(0600,%apache_user,%apache_group) %ghost %a_proxycachedir/mod_ssl/scache.pag
%attr(0600,%apache_user,%apache_group) %ghost %a_proxycachedir/mod_ssl/scache.sem

%files devel
%a_prefix/build
%a_includedir/.mmn
%a_includedir/ap_*
%a_includedir/[hmoprsu]*

#%a_libexecdir/httpd.exp
#%a_installbuilddir/config.nice


%a_sbindir/apxs*
%a_mandir/man8/apxs*
%dir %a_installbuilddir
%a_installbuilddir/[clprs]*.mk
%a_installbuilddir/instdso.sh

%a_sbindir/envvars*
%attr(0644,root,root) %_sysconfdir/rpm/macros.d/*

%files suexec
%config(noreplace) %a_mods_available/suexec.load
%a_libexecdir/mod_suexec.so
%attr(4510,root,%apache_group) %a_sbindir/suexec*
%a_mandir/man8/suexec*


%changelog
* Wed May 02 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt24
- Building mod_authnz_ldap: --enable-authnz-ldap using
- Creating apache2-httpd-event subpackage
- Update apache2-alt-alternatives-*.tar to apache2-alt-alternatives-0.2.tar:
  add alternative for /usr/sbin/httpd2.event

* Sat Apr 28 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt23
- Using --with-program-name=%a_dname for all server build:
  + only defoult program name (is %%a_dname) for all %%a_dname.*
  + only defoult config name (is %%a_dname.conf) for all %%a_dname.*
- Removing %a_dname.*.conf link
- Remove Requires %%name-httpd-prefork and %%name-httpd-worker in
  %%name-devel subpackage

* Wed Apr 25 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt22
- Removing debug message in %%pre %%name
- Fix %%register_alternatives for %%name-httpd-worker
- Fix #11531: adding sleep 1 to init scripts

* Mon Apr 09 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt20
- Update *-debian.conf-*.patch to apache2-2.2.4-alt-debian.conf-0.10.patch
  + fix support/a2chkconfig.in (#11395): read all string
    in conf/*-start.d/*.conf
  + fix #11333: adding man to a2chkconfig (thanks to Avramenko Andrew)
- Update *-alt-configs-* to apache2-alt-configs-0.4. Adding to conf/:
  + mods-start.d/010-manual.conf
  + mods-start.d/020-manual-addons.conf
  + extra-start.d/020-httpd-manual.conf (#11410)
  + extra-start.d/030-httpd-manual-addons.conf
- Man to suexec moving to %%name-suexec subpackage

* Fri Apr 06 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt19
- Add Requires %%name-httpd-prefork and %%name-httpd-worker to
  %%name-devel subpackage
- Remove %%name-init subpackage
- Fix packages updating

* Thu Apr 05 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt18
- Add Provides to %%name-common subpackage:
  + %%name-mmn
  + %%name-libdb
- Remove Provides:
  + %%name-common-mmn
  + %%name-common-libdb
- Updating %%a_sbindir/%%a_dname:
  + renamed %%a_sbindir/%%a_dname to %%a_sbindir/%%a_dname.prefork
  + use alternatives for create symlinc %%a_sbindir/%%a_dname to
    %%a_sbindir/%%a_dname.prefork or %%a_sbindir/%%a_dname.worker
- Adding symlink for %%a_sysconfdir/%%a_dname.conf:
  + %%a_sysconfdir/%%a_dname.prefork.conf
- Adding trigger scripts to %%a_dname for update/remove
  apache2-{init,httpd-{prefork,worker}}

* Tue Apr 03 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt17
- Creating subpackage:
  + apache2-common
  + apache2-httpd-{worker,prefork}
  + apache2-init
- Update *-alt-configs-* to apache2-alt-configs-0.3
  + adding httpd-manual-addons.conf, for using @apache_addondocdir@

* Sun Apr 01 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt16
- Disable httpd2 service startup by default (#11280):
  that might lead to undesired consequences in case of 
  "accidentally" installed packages and/or forgetting
  about them while configuring services; see also [ru]:
  http://lists.altlinux.org/pipermail/devel/2006-December/039909.html
- Fix creating the %%a_sysconfdir/%%a_dname.conf when updating
- Update *-debian.conf-*.patch to apache2-2.2.4-alt-debian.conf-0.9.patch
  + fix widely reported in the a2chkconfig (#11274)
  + fix messages from a2{en,dis}{mod,site,port,extra} (#11247)


* Thu Mar 29 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt15
- Update *-debian.conf-*.patch to apache2-2.2.4-alt-debian.conf-0.8.patch
  + Fix #11247
- Update *-alt-configs-* to apache2-alt-configs-0.2
  + Fix #11245
  + Fix #11246
- Adding README.ALT.ru_RU.KOI8-R

* Mon Mar 26 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt14
- Removing apache2-2.2.4-alt-conf.in-A1PROXIED.patch (is old)
- default-0.1.a2chkconfig.tar updated to apache2-alt-configs-0.1.tar
  + add defoult configs for virtual hosts template, A1PROXIED using and
    for using old @rel_sysconfdir@/addon.d
- Fix User, Group and ServerAdmin sets to configs
- Unused SSL option
- Removing dirs (unused, is old):
  + %%apache_vhosttempldir
  + %%apache_vhostconfdir
  + %%apache_addonvhostconfdir
- Update *-debian.conf-*.patch to apache2-2.2.4-alt-debian.conf-0.7.patch
  + fix: remove using /etc/httpd2/conf/extra/httpd-manual.conf

* Mon Mar 26 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt13
- Update *-debian.conf-*.patch to apache2-2.2.4-alt-debian.conf-0.6.patch
  + fix support/a2chkconfig.in
- Add apache2-2.2.4-alt-default_https.conf.in.0.1.patch
  + fix SSL keys patchs
- Renamed macros:
  + %%ad_name to %%a_dname
  + %%apache_apxs to %%a_apxs
  + %%apache_addondocdir to %%a_addondocdir
- Removing macros in spec:
  + %%apache_basedir (use %%a_prefix)
  + %%apache_confdir (use %%a_sysconfdir)
  + %%apache_datadir (use %%a_datadir)
  + %%apache_htdocsdir (use %%a_docsdir)
  + %%apache_cgibindir (use %%a_cgidir)
  + %%apache_logdir (use %%a_logfiledir)
  + %%apache_moduledir (use %%a_libexecdir)
- Use sed script for substitute the real paths in all configs
- Fix scripts

* Sun Mar 25 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt12
- Not using old configs
  + renamed old %%a_sysconfdir/%%ad_name{,.worker}.conf to
    %%a_sysconfdir/%%ad_name{,.worker}.conf.rpmold
  + create new %%a_sysconfdir/%%ad_name{,.worker}.conf
- Update *-debian.conf-*.patch to apache2-2.2.4-alt-debian.conf-0.5.patch
  + fix adding %%a_sbindir/a2{en,dis}{port,extra}
  + adding create %%a_sbindir/{extra,ports,sites,mods}-start.d
  + add %%a_sbindir/a2chkconfig
- Adding %%a_sysconfdir/*-start.d/*.conf (configs files for a2chkconfig)
- Fix missed $OPTIONS variable in conftest() function in the init script
  (bug#11156): use patch from Nikolay A. Fetisov <naf@altlinux.org>
- Renamed old %%a_manualdir to %%a_manualdir.rpmold, for create symlink to
  %%_docdir/%%a_name-manual-%%apache_version/manual
- Moveing %%a_manualdir to %%_docdir/%%a_name-manual-%%apache_version/manual
  and create symlink from %%a_manualdir
- Using TMPDIR=/var/spool/apache2/tmp in init script
- Add triggerpostun fo deleting old symlink
  %%_docdir/apache2-manual-2.2.4/manual

* Sun Mar 18 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt11
- Update *-debian.conf-*.patch to apache2-2.2.4-alt-debian.conf-0.4.patch
  + add %%a_sbindir/a2{en,dis}{port,extra}
  + fix Makefile.in (for configs create)

* Sun Mar 18 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt10
- Update *-debian.conf-*.patch to apache2-2.2.4-alt-debian.conf-0.3.patch
  + fix %%a_sbindir/a2{en,dis}site
  + using <IfModule authz_host_module> in *.conf files

* Fri Mar 16 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt9
- Remove old patchs:
  + httpd-2.0.55-alt-build.patch
- Add utils:
  + %%a_sbindir/a2{en,dis}{mod,site}
  + %%a_sbindir/check_forensic
- Add mans:
  + a2{en,dis}mod.8
  + checkgid.8
  + check_forensic.8
- Update *-debian.conf-*.patch to apache2-2.2.4-alt-debian.conf-0.2.patch

* Thu Mar 15 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt8
- Add apache2-2.2.4-alt-debian.conf-0.1.patch, for using Debian`like
  cofigs dirs:
  + %%a_sysconfdir/extra-available/
  + %%a_sysconfdir/extra-enabled/
  + %%a_sysconfdir/mods-available/
  + %%a_sysconfdir/mods-enabled/
  + %%a_sysconfdir/ports-available/
  + %%a_sysconfdir/ports-enabled/
  + %%a_sysconfdir/sites-available/
  + %%a_sysconfdir/sites-enabled/
- Remove old patchs:
  + apache2-2.2.4-alt-conf.in-include-0.1.patch
  + apache2-2.2.4-alt-Makefile.in-SSL.patch
  + apache2-2.2.4-alt-Makefile.in-LoadModule.patch

* Wed Mar 07 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt7
- Add dir provides:
  + %%a_proxycachedir/
  + %%_spooldir/apache%%apache_branch/{,tmp,sessions,uploads}

* Wed Feb 28 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt6
- Link with system PCRE library!
- Update warning message from %%pre

* Mon Feb 26 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt5
- set requires for %%name-mod_ssl
  + %%name = %%apache_version-%%apache_release
  + %%name-libdb = %%n_dbver
- modufy auto update in %%pre:
  + update %%a_sysconfdir/httpd2{,.worker}.conf only


* Tue Feb 20 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt4
- use apache2-2.2.4-alt-conf.in-0.2.patch:
  + corected module name for using in <IfModule ...>
- no modify defoult root page (use original upstrem page)
- remove use`nt files:
  + altlinux.html
  + altlinux.png
- no corected path to perl
- moved to apache2-suexec:
  + %%a_sysconfdir/modules.d/A.[0-9][0-9][0-9]_suexec.conf
  + %%a_libexecdir/mod_suexec.so

* Fri Feb 16 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt3
- auto update %%a_sysconfdir/httpd2*.conf including in %%pre:
  + added "Include /etc/httpd2/conf/modules.d/A.*.conf"
  + commented all LoadModule directives
- use %%post_service httpd%%apache_branch in mod_ssl pakage

* Tue Feb 13 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt2
- adding %%a_sysconfdir/extra/httpd-ssl.conf to apache2-mod_ssl
- update apache2-2.2.4-alt-conf.in.patch to 0.1:
  + update patchs for SSL keys
- update apache2-2.2.4-alt-conf.in-include-0.1.patch:
  + activate httpd-ssl.conf including
- adding apache2-2.2.4-alt-Makefile.in-LoadModule.patch:
  + create %%a_sysconfdir/modules.d/A.*.conf for LoadModule using

* Sun Feb 11 2007 Aleksey Avdeev <solo@altlinux.ru> 2.2.4-alt1
- 2.2.4
- use PrintPath
- add htcacheclean
- add patchs:
  + apache2-2.2.4-alt-conf.in.patch
  + apache2-2.2.4-alt-conf.in-include.patch
  + apache2-2.2.4-alt-conf.in-A1PROXIED.patch
  + apache2-2.2.4-alt-Makefile.in-SSL.patch
- apache_native_apr switch delete:
  + no build native libapr
  + use external libapr1 onli
- prevent build if upstream MMN differs from mmn macro
- merge 2.0.59-alt0.M24.1:
  + set pkgconfig in BuildPreReq

* Wed Nov 01 2006 Aleksey Avdeev <solo@altlinux.ru> 2.0.59-alt3
- fix build: add patch from Sviatoslav Sviridov <svd@altlinux.ru>
  for spec

* Tue Oct 31 2006 Aleksey Avdeev <solo@altlinux.ru> 2.0.59-alt2
- build libdb4.4 to defoult
- add new provides: %%name-libdb = %%n_dbver
- turn back conditional libdb4.4-devel, libdb4.3-devel (for Compact 3.0)
  or libdb4.2-devel (for Master 2.4) build

* Sun Oct 22 2006 Sviatoslav Sviridov <svd@altlinux.ru> 2.0.59-alt1.1.libdb4.4
- Rebuild with libdb4.4

* Mon Jul 31 2006 Aleksey Avdeev <solo@altlinux.ru> 2.0.59-alt1
- 2.0.59

* Wed Jul 12 2006 Aleksey Avdeev <solo@altlinux.ru> 2.0.55-alt9
- rebuilt for update libldap (use libldap-2.3)

* Sat Apr 01 2006 Aleksey Avdeev <solo@altlinux.ru> 2.0.55-alt8
- link with no system PCRE library (old!)

* Wed Mar 29 2006 Dmitry V. Levin <ldv@altlinux.org> 2.0.55-alt7.2
- Fixed build with ld --as-needed.
- Link with system PCRE library!

* Wed Mar 29 2006 Aleksey Avdeev <solo@altlinux.ru> 2.0.55-alt7
- hack for --as-needed fix

* Sun Mar 19 2006 Aleksey Avdeev <solo@altlinux.ru> 2.0.55-alt5
- update spec for backports in 3.0

* Thu Mar 09 2006 Aleksey Avdeev <solo@altlinux.ru> 2.0.55-alt4
- merge 2.0.55-alt0.M24.1 (Grigory Batalov <bga@altlinux.ru>):
  + check for libapr >= 0.9.7
  + turn back conditional static build
  + delaycompress in logrotate config
  + change /usr/sbin/service to /sbin/service in logrotate config
  + change service to reload to httpd2 in logrotate config
  + log dir owned by apache2 group
  + htdocs dir owned by webmaster group
- update conditional static build
- turn back conditional libdb4.3-devel or libdb4.2-devel
  (for Master 2.4) build

* Mon Jan 23 2006 Anton Farygin <rider@altlinux.ru> 2.0.55-alt3.1
- NMU:
    - requires fixed (libdb4.2-devel-static changed to libdb4.3-devel)
    - tested build for x86_64

* Wed Nov 23 2005 Yury Konovalov <yurix@altlinux.ru> 2.0.55-alt3
- Require newer apr bug #8517

* Mon Nov 21 2005 Yury Konovalov <yurix@altlinux.ru> 2.0.55-alt2
- fix bug #7490

* Sat Oct 15 2005 Yury Konovalov <yurix@altlinux.ru> 2.0.55-alt1
- 2.0.55
- adopt to new ALT common macroses behaivour

* Mon Aug 15 2005 Yury Konovalov <yurix@altlinux.ru> 2.0.54-alt2
- remove unexpanded macros apache2-suexec Bug#:7490

* Tue Apr 19 2005 Yury Konovalov <yurix@altlinux.ru> 2.0.54-alt1
- 2.0.54
- fix initscript hostname handling (bug#6291)

* Mon Dec 27 2004 Sviatoslav Sviridov <svd@altlinux.ru> 2.0.52-alt3
- updated alt-configure patch to check for available libldap
  and link with libldap
- applied patches:
  + httpd-2.0.52-sslauth.patch
  + httpd-2.0.52-SSLCipherSuite-bypass-CAN-2004-0885.diff
  + httpd-2.0.52-memory-consumption-DoS-CAN-2004-0942.diff
  + util_ldap_cache_mgr.c.patch

* Sun Nov 14 2004 Dmitry V. Levin <ldv@altlinux.org> 2.0.52-alt2
- Fixed build with system libapr/libaprutil,
  patch from Sviatoslav Sviridov.
- Built with system libapr/libaprutil and openldap-2.2.18-alt3.

* Wed Oct 20 2004 Yury Konovalov <yurix@altlinux.ru> 2.0.52-alt1
- 2.0.52
- build with native apr

* Thu Sep 16 2004 Yury Konovalov <yurix@altlinux.ru> 2.0.51-alt1
- 2.0.51

* Sun Aug 29 2004 Yury Konovalov <yurix@altlinux.ru> 2.0.50-alt4
- fix build failed with APR

* Mon Jul 12 2004 Yury Konovalov <yurix@altlinux.ru> 2.0.50-alt3
- rpm trigger script removed

* Mon Jul 05 2004 Yury Konovalov <yurix@altlinux.ru> 2.0.50-alt2
- rebuild

* Tue Jun 29 2004 Yury Konovalov <yurix@altlinux.ru> 2.0.50-alt1
- 2.0.50
- provide favour description file for apachkconfig

* Mon Jun 07 2004 Yury Konovalov <yurix@altlinux.ru> 2.0.49-alt2
- added vhost.d-addon directory and apache_addonvhostconfdir RPM macros
- apache now use apache2 user/group account by default
- Include only A.*.conf files from addon.d vhosts.d vhosts.d-addon dirs
  to make configs been disabled by default.
- Add AliasMatch to manual-addons directory. Also link is included in main
  manual page

* Tue May 18 2004 Yury Konovalov <yurix@altlinux.ru> 2.0.49-alt1
- rebuild for current Sisyphus
- use vhosts-filesystem macroses for default docroot and vhosts directory.
- provide vhosts config template to be used by upcoming vhosts management scripts.
- 2.0.49

* Sat Nov 15 2003 Yury Konovalov <yurix@altlinux.ru> 2.0.48-uc4
- provide apache2-liapr* packages in case build with internal apr
  otherwise make apache2-devel provide fake apache2-liapr* packages
- provide conf.d and vhost.d configuration directories.
  (Thank you, Sviataslau Svirydau for the ideas)

* Wed Nov 12 2003 Yury Konovalov <yurix@altlinux.ru> 2.0.48-uc3
- use %%make_build instead of make %%{?_smp_mflags}.
- smp patch for makefile applied.
  (Thanks for the above changes goes to Sviataslau Svirydau)

* Tue Nov 11 2003 Yury Konovalov <yurix@altlinux.ru> 2.0.48-uc2
- build charset_lite module
- apache_native_apr switch added to enable build with external
  apr.
- fix buildreq
  (Thanks to Sviataslau Svirydau for pointing this)

* Sat Nov 01 2003 Yury Konovalov <yurix@altlinux.ru> 2.0.48-uc1
- Remove Alt layout file. Autogenerate it from spec instead
- Provide option to build packages that could be installed on
  the same host with ru-apache
- Make spec to look like those for russian apache
    - move suexec into suexec package
    - update macroses to be ru-apache compatible
    - provide rpm macros in devel package
    - steal distrib detection method from ru-apache package
- 2.0.48

* Tue Sep 09 2003 Yury Konovalov <yurix@altlinux.ru> 2.0.46-uc2
- Fix prefix to be apache_root.

* Wed Aug 27 2003 Yury Konovalov <yurix@altlinux.ru> 2.0.46-uc1
- First build for ALTLinux.

* Sat Apr 5 2003 Graham Leggett <minfrin@apache.org> 2.0.46-dev
- Moved mime.types back to the default location.
- Added mod_ldap and friends, mod_cache and friends.
- Added openldap dependancy.

* Sun Mar 30 2003 Graham Leggett <minfrin@apache.org> 2.0.45-1
- Created generic Apache rpm spec file from that donated by Redhat.
- Removed Redhat specific patches and boilerplate files.
- Removed SSL related Makefiles.

* Mon Feb 24 2003 Joe Orton <jorton@redhat.com> 2.0.40-21
- add security fix for CAN-2003-0020; replace non-printable characters
  with '!' when printing to error log.
- disable debuginfo on IA64.

* Tue Feb 11 2003 Joe Orton <jorton@redhat.com> 2.0.40-20
- disable POSIX semaphores to support 2.4.18 kernel (#83324)

* Wed Jan 29 2003 Joe Orton <jorton@redhat.com> 2.0.40-19
- require xmlto 0.0.11 or later
- fix apr_strerror on glibc2.3

* Wed Jan 22 2003 Tim Powers <timp@redhat.com> 2.0.40-18
- rebuilt

* Thu Jan 16 2003 Joe Orton <jorton@redhat.com> 2.0.40-17
- add mod_cgid and httpd binary built with worker MPM (#75496)
- allow choice of httpd binary in init script
- pick appropriate CGI module based on loaded MPM in httpd.conf
- source /etc/sysconfig/httpd in apachectl to get httpd choice
- make "apachectl status" fail gracefully when links isn't found (#78159)

* Mon Jan 13 2003 Joe Orton <jorton@redhat.com> 2.0.40-16
- rebuild for OpenSSL 0.9.7

* Fri Jan  3 2003 Joe Orton <jorton@redhat.com> 2.0.40-15
- fix possible infinite recursion in config dir processing (#77206)
- fix memory leaks in request body processing (#79282)

* Thu Dec 12 2002 Joe Orton <jorton@redhat.com> 2.0.40-14
- remove unstable shmht session cache from mod_ssl
- get SSL libs from pkg-config if available (Nalin Dahyabhai)
- stop "apxs -a -i" from inserting AddModule into httpd.conf (#78676)

* Wed Nov  6 2002 Joe Orton <jorton@redhat.com> 2.0.40-13
- fix location of installbuilddir in apxs when libdir!=/usr/lib

* Wed Nov  6 2002 Joe Orton <jorton@redhat.com> 2.0.40-12
- pass libdir to configure; clean up config_vars.mk
- package instdso.sh, fixing apxs -i (#73428)
- prevent build if upstream MMN differs from mmn macro
- remove installed but unpackaged files

* Wed Oct  9 2002 Joe Orton <jorton@redhat.com> 2.0.40-11
- correct SERVER_NAME encoding in i18n error pages (thanks to Andre Malo)

* Wed Oct  9 2002 Joe Orton <jorton@redhat.com> 2.0.40-10
- fix patch for CAN-2002-0840 to also cover i18n error pages

* Wed Oct  2 2002 Joe Orton <jorton@redhat.com> 2.0.40-9
- security fixes for CAN-2002-0840 and CAN-2002-0843
- fix for possible mod_dav segfault for certain requests

* Tue Sep 24 2002 Gary Benson <gbenson@redhat.com>
- updates to the migration guide

* Wed Sep  4 2002 Nalin Dahyabhai <nalin@redhat.com> 2.0.40-8
- link httpd with libssl to avoid library loading/unloading weirdness

* Tue Sep  3 2002 Joe Orton <jorton@redhat.com> 2.0.40-7
- add LoadModule lines for proxy modules in httpd.conf (#73349)
- fix permissions of conf/ssl.*/ directories; add Makefiles for
  certificate management (#73352)

* Mon Sep  2 2002 Joe Orton <jorton@redhat.com> 2.0.40-6
- provide "httpd-mmn" to manage module ABI compatibility

* Sun Sep  1 2002 Joe Orton <jorton@redhat.com> 2.0.40-5
- fix SSL session cache (#69699)
- revert addition of LDAP support to apr-util

* Mon Aug 26 2002 Joe Orton <jorton@redhat.com> 2.0.40-4
- set SIGXFSZ disposition to "ignored" (#69520)
- make dummy connections to the first listener in config (#72692)

* Mon Aug 26 2002 Joe Orton <jorton@redhat.com> 2.0.40-3
- allow "apachectl configtest" on a 1.3 httpd.conf
- add mod_deflate
- enable LDAP support in apr-util
- don't package everything in /var/www/error as config(noreplace)

* Wed Aug 21 2002 Bill Nottingham <notting@redhat.com> 2.0.40-2
- add trigger (#68657)

* Mon Aug 12 2002 Joe Orton <jorton@redhat.com> 2.0.40-1
- update to 2.0.40

* Wed Jul 24 2002 Joe Orton <jorton@redhat.com> 2.0.36-8
- improve comment on use of UserDir in default config (#66886)

* Wed Jul 10 2002 Joe Orton <jorton@redhat.com> 2.0.36-7
- use /sbin/nologin as shell for apache user (#68371)
- add patch from CVS to fix possible infinite loop when processing
  internal redirects

* Wed Jun 26 2002 Gary Benson <gbenson@redhat.com> 2.0.36-6
- modify init script to detect 1.3.x httpd.conf's and direct users
  to the migration guide

* Tue Jun 25 2002 Gary Benson <gbenson@redhat.com> 2.0.36-5
- patch apachectl to detect 1.3.x httpd.conf's and direct users
  to the migration guide
- ship the migration guide

* Fri Jun 21 2002 Joe Orton <jorton@redhat.com>
- move /etc/httpd2 back to /etc/httpd
- add noindex.html page and poweredby logo; tweak default config
  to load noindex.html if no default "/" page is present.
- add patch to prevent mutex errors on graceful restart

* Fri Jun 21 2002 Tim Powers <timp@redhat.com> 2.0.36-4
- automated rebuild

* Wed Jun 12 2002 Joe Orton <jorton@redhat.com> 2.0.36-3
- add patch to fix SSL mutex handling

* Wed Jun 12 2002 Joe Orton <jorton@redhat.com> 2.0.36-2
- improved config directory patch

* Mon May 20 2002 Joe Orton <jorton@redhat.com>
- initial build; based heavily on apache.spec and mod_ssl.spec
- fixes: #65214, #58490, #57376, #61265, #65518, #58177, #57245
